# define omp_get_num_threads t_2_1_omp_get_num_threads
# define omp_get_thread_num t_2_1_omp_get_thread_num
# define omp_get_max_threads t_2_1_omp_get_max_threads
# define cmp t_2_1_cmp
# define taco_gallop t_2_1_taco_gallop
# define taco_binarySearchAfter t_2_1_taco_binarySearchAfter
# define taco_binarySearchBefore t_2_1_taco_binarySearchBefore
# define init_taco_tensor_t t_2_1_init_taco_tensor_t
# define deinit_taco_tensor_t t_2_1_deinit_taco_tensor_t
// Generated by the Tensor Algebra Compiler (tensor-compiler.org)
// /nix/store/k9ygr43gc7gzdk9r6nfz8m7c3fbi6f9x-python3.10-taco-2b8ece4/bin/taco "P(a,u) = Pi(a,b) * Ji(b,u)" -f=P:dd -f=Pi:dd -f=Ji:ds -t=P:double -t=Pi:double -t=Ji:double -write-compute=t_2_1__.c -write-source=t_2_1_.c -prefix=t_2_1_
#ifndef TACO_C_HEADERS
#define TACO_C_HEADERS
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <math.h>
#include <complex.h>
#include <string.h>
#if _OPENMP
#include <omp.h>
#endif
#define TACO_MIN(_a,_b) ((_a) < (_b) ? (_a) : (_b))
#define TACO_MAX(_a,_b) ((_a) > (_b) ? (_a) : (_b))
#define TACO_DEREF(_a) (((___context___*)(*__ctx__))->_a)
#ifndef TACO_TENSOR_T_DEFINED
#define TACO_TENSOR_T_DEFINED
typedef enum { taco_mode_dense, taco_mode_sparse } taco_mode_t;
typedef struct {
  int32_t      order;         // tensor order (number of modes)
  int32_t*     dimensions;    // tensor dimensions
  int32_t      csize;         // component size
  int32_t*     mode_ordering; // mode storage ordering
  taco_mode_t* mode_types;    // mode storage types
  uint8_t***   indices;       // tensor index data (per mode)
  uint8_t*     vals;          // tensor values
  uint8_t*     fill_value;    // tensor fill value
  int32_t      vals_size;     // values array size
} taco_tensor_t;
#endif
#if !_OPENMP
int omp_get_thread_num() { return 0; }
int omp_get_max_threads() { return 1; }
#endif
int cmp(const void *a, const void *b) {
  return *((const int*)a) - *((const int*)b);
}
int taco_gallop(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayStart] >= target || arrayStart >= arrayEnd) {
    return arrayStart;
  }
  int step = 1;
  int curr = arrayStart;
  while (curr + step < arrayEnd && array[curr + step] < target) {
    curr += step;
    step = step * 2;
  }

  step = step / 2;
  while (step > 0) {
    if (curr + step < arrayEnd && array[curr + step] < target) {
      curr += step;
    }
    step = step / 2;
  }
  return curr+1;
}
int taco_binarySearchAfter(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayStart] >= target) {
    return arrayStart;
  }
  int lowerBound = arrayStart; // always < target
  int upperBound = arrayEnd; // always >= target
  while (upperBound - lowerBound > 1) {
    int mid = (upperBound + lowerBound) / 2;
    int midValue = array[mid];
    if (midValue < target) {
      lowerBound = mid;
    }
    else if (midValue > target) {
      upperBound = mid;
    }
    else {
      return mid;
    }
  }
  return upperBound;
}
int taco_binarySearchBefore(int *array, int arrayStart, int arrayEnd, int target) {
  if (array[arrayEnd] <= target) {
    return arrayEnd;
  }
  int lowerBound = arrayStart; // always <= target
  int upperBound = arrayEnd; // always > target
  while (upperBound - lowerBound > 1) {
    int mid = (upperBound + lowerBound) / 2;
    int midValue = array[mid];
    if (midValue < target) {
      lowerBound = mid;
    }
    else if (midValue > target) {
      upperBound = mid;
    }
    else {
      return mid;
    }
  }
  return lowerBound;
}
taco_tensor_t* init_taco_tensor_t(int32_t order, int32_t csize,
                                  int32_t* dimensions, int32_t* mode_ordering,
                                  taco_mode_t* mode_types) {
  taco_tensor_t* t = (taco_tensor_t *) malloc(sizeof(taco_tensor_t));
  t->order         = order;
  t->dimensions    = (int32_t *) malloc(order * sizeof(int32_t));
  t->mode_ordering = (int32_t *) malloc(order * sizeof(int32_t));
  t->mode_types    = (taco_mode_t *) malloc(order * sizeof(taco_mode_t));
  t->indices       = (uint8_t ***) malloc(order * sizeof(uint8_t***));
  t->csize         = csize;
  for (int32_t i = 0; i < order; i++) {
    t->dimensions[i]    = dimensions[i];
    t->mode_ordering[i] = mode_ordering[i];
    t->mode_types[i]    = mode_types[i];
    switch (t->mode_types[i]) {
      case taco_mode_dense:
        t->indices[i] = (uint8_t **) malloc(1 * sizeof(uint8_t **));
        break;
      case taco_mode_sparse:
        t->indices[i] = (uint8_t **) malloc(2 * sizeof(uint8_t **));
        break;
    }
  }
  return t;
}
void deinit_taco_tensor_t(taco_tensor_t* t) {
  for (int i = 0; i < t->order; i++) {
    free(t->indices[i]);
  }
  free(t->indices);
  free(t->dimensions);
  free(t->mode_ordering);
  free(t->mode_types);
  free(t);
}
#endif

int t_2_1_compute(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  int P2_dimension = (int)(P->dimensions[1]);
  double* restrict P_vals = (double*)(P->vals);
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  int Pi2_dimension = (int)(Pi->dimensions[1]);
  double* restrict Pi_vals = (double*)(Pi->vals);
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  #pragma omp parallel for schedule(static)
  for (int32_t pP = 0; pP < (P1_dimension * P2_dimension); pP++) {
    P_vals[pP] = 0.0;
  }

  #pragma omp parallel for schedule(runtime)
  for (int32_t a = 0; a < Pi1_dimension; a++) {
    for (int32_t b = 0; b < Ji1_dimension; b++) {
      int32_t bPi = a * Pi2_dimension + b;
      for (int32_t uJi = Ji2_pos[b]; uJi < Ji2_pos[(b + 1)]; uJi++) {
        int32_t u = Ji2_crd[uJi];
        int32_t uP = a * P2_dimension + u;
        P_vals[uP] = P_vals[uP] + Pi_vals[bPi] * Ji_vals[uJi];
      }
    }
  }
  return 0;
}

int t_2_1_assemble(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  int P2_dimension = (int)(P->dimensions[1]);
  double* restrict P_vals = (double*)(P->vals);

  P_vals = (double*)malloc(sizeof(double) * (P1_dimension * P2_dimension));

  P->vals = (uint8_t*)P_vals;
  return 0;
}

int t_2_1_evaluate(taco_tensor_t *P, taco_tensor_t *Pi, taco_tensor_t *Ji) {
  int P1_dimension = (int)(P->dimensions[0]);
  int P2_dimension = (int)(P->dimensions[1]);
  double* restrict P_vals = (double*)(P->vals);
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  int Pi2_dimension = (int)(Pi->dimensions[1]);
  double* restrict Pi_vals = (double*)(Pi->vals);
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  int32_t P_capacity = P1_dimension * P2_dimension;
  P_vals = (double*)malloc(sizeof(double) * P_capacity);

  #pragma omp parallel for schedule(static)
  for (int32_t pP = 0; pP < P_capacity; pP++) {
    P_vals[pP] = 0.0;
  }

  #pragma omp parallel for schedule(runtime)
  for (int32_t a = 0; a < Pi1_dimension; a++) {
    for (int32_t b = 0; b < Ji1_dimension; b++) {
      int32_t bPi = a * Pi2_dimension + b;
      for (int32_t uJi = Ji2_pos[b]; uJi < Ji2_pos[(b + 1)]; uJi++) {
        int32_t u = Ji2_crd[uJi];
        int32_t uP = a * P2_dimension + u;
        P_vals[uP] = P_vals[uP] + Pi_vals[bPi] * Ji_vals[uJi];
      }
    }
  }

  P->vals = (uint8_t*)P_vals;
  return 0;
}

/*
 * The `pack` functions convert coordinate and value arrays in COO format,
 * with nonzeros sorted lexicographically by their coordinates, to the
 * specified input format.
 *
 * The `unpack` function converts the specified output format to coordinate
 * and value arrays in COO format.
 *
 * For both, the `_COO_pos` arrays contain two elements, where the first is 0
 * and the second is the number of nonzeros in the tensor.
 */

int t_2_1_pack_Pi(taco_tensor_t *Pi, int* Pi_COO1_pos, int* Pi_COO1_crd, int* Pi_COO2_crd, double* Pi_COO_vals) {
  int Pi1_dimension = (int)(Pi->dimensions[0]);
  int Pi2_dimension = (int)(Pi->dimensions[1]);
  double* restrict Pi_vals = (double*)(Pi->vals);

  int32_t Pi_capacity = Pi1_dimension * Pi2_dimension;
  Pi_vals = (double*)malloc(sizeof(double) * Pi_capacity);

  #pragma omp parallel for schedule(static)
  for (int32_t pPi = 0; pPi < Pi_capacity; pPi++) {
    Pi_vals[pPi] = 0.0;
  }

  int32_t aPi_COO = Pi_COO1_pos[0];
  int32_t pPi_COO1_end = Pi_COO1_pos[1];

  while (aPi_COO < pPi_COO1_end) {
    int32_t a = Pi_COO1_crd[aPi_COO];
    int32_t Pi_COO1_segend = aPi_COO + 1;
    while (Pi_COO1_segend < pPi_COO1_end && Pi_COO1_crd[Pi_COO1_segend] == a) {
      Pi_COO1_segend++;
    }
    int32_t bPi_COO = aPi_COO;

    while (bPi_COO < Pi_COO1_segend) {
      int32_t b = Pi_COO2_crd[bPi_COO];
      double Pi_COO_val = Pi_COO_vals[bPi_COO];
      bPi_COO++;
      while (bPi_COO < Pi_COO1_segend && Pi_COO2_crd[bPi_COO] == b) {
        Pi_COO_val += Pi_COO_vals[bPi_COO];
        bPi_COO++;
      }
      int32_t bPi = a * Pi2_dimension + b;
      Pi_vals[bPi] = Pi_COO_val;
    }
    aPi_COO = Pi_COO1_segend;
  }

  Pi->vals = (uint8_t*)Pi_vals;
  return 0;
}

int t_2_1_pack_Ji(taco_tensor_t *Ji, int* Ji_COO1_pos, int* Ji_COO1_crd, int* Ji_COO2_crd, double* Ji_COO_vals) {
  int Ji1_dimension = (int)(Ji->dimensions[0]);
  int* restrict Ji2_pos = (int*)(Ji->indices[1][0]);
  int* restrict Ji2_crd = (int*)(Ji->indices[1][1]);
  double* restrict Ji_vals = (double*)(Ji->vals);

  Ji2_pos = (int32_t*)malloc(sizeof(int32_t) * (Ji1_dimension + 1));
  Ji2_pos[0] = 0;
  for (int32_t pJi2 = 1; pJi2 < (Ji1_dimension + 1); pJi2++) {
    Ji2_pos[pJi2] = 0;
  }
  int32_t Ji2_crd_size = 1048576;
  Ji2_crd = (int32_t*)malloc(sizeof(int32_t) * Ji2_crd_size);
  int32_t uJi = 0;
  int32_t Ji_capacity = 1048576;
  Ji_vals = (double*)malloc(sizeof(double) * Ji_capacity);

  int32_t bJi_COO = Ji_COO1_pos[0];
  int32_t pJi_COO1_end = Ji_COO1_pos[1];

  while (bJi_COO < pJi_COO1_end) {
    int32_t b = Ji_COO1_crd[bJi_COO];
    int32_t Ji_COO1_segend = bJi_COO + 1;
    while (Ji_COO1_segend < pJi_COO1_end && Ji_COO1_crd[Ji_COO1_segend] == b) {
      Ji_COO1_segend++;
    }
    int32_t pJi2_begin = uJi;

    int32_t uJi_COO = bJi_COO;

    while (uJi_COO < Ji_COO1_segend) {
      int32_t u = Ji_COO2_crd[uJi_COO];
      double Ji_COO_val = Ji_COO_vals[uJi_COO];
      uJi_COO++;
      while (uJi_COO < Ji_COO1_segend && Ji_COO2_crd[uJi_COO] == u) {
        Ji_COO_val += Ji_COO_vals[uJi_COO];
        uJi_COO++;
      }
      if (Ji_capacity <= uJi) {
        Ji_vals = (double*)realloc(Ji_vals, sizeof(double) * (Ji_capacity * 2));
        Ji_capacity *= 2;
      }
      Ji_vals[uJi] = Ji_COO_val;
      if (Ji2_crd_size <= uJi) {
        Ji2_crd = (int32_t*)realloc(Ji2_crd, sizeof(int32_t) * (Ji2_crd_size * 2));
        Ji2_crd_size *= 2;
      }
      Ji2_crd[uJi] = u;
      uJi++;
    }

    Ji2_pos[b + 1] = uJi - pJi2_begin;
    bJi_COO = Ji_COO1_segend;
  }

  int32_t csJi2 = 0;
  for (int32_t pJi20 = 1; pJi20 < (Ji1_dimension + 1); pJi20++) {
    csJi2 += Ji2_pos[pJi20];
    Ji2_pos[pJi20] = csJi2;
  }

  Ji->indices[1][0] = (uint8_t*)(Ji2_pos);
  Ji->indices[1][1] = (uint8_t*)(Ji2_crd);
  Ji->vals = (uint8_t*)Ji_vals;
  return 0;
}

int t_2_1_unpack(int** P_COO1_pos_ptr, int** P_COO1_crd_ptr, int** P_COO2_crd_ptr, double** P_COO_vals_ptr, taco_tensor_t *P) {
  int* P_COO1_pos;
  int* P_COO1_crd;
  int* P_COO2_crd;
  double* P_COO_vals;
  int P1_dimension = (int)(P->dimensions[0]);
  int P2_dimension = (int)(P->dimensions[1]);
  double* restrict P_vals = (double*)(P->vals);

  P_COO1_pos = (int32_t*)malloc(sizeof(int32_t) * 2);
  P_COO1_pos[0] = 0;
  int32_t P_COO1_crd_size = 1048576;
  P_COO1_crd = (int32_t*)malloc(sizeof(int32_t) * P_COO1_crd_size);
  int32_t P_COO2_crd_size = 1048576;
  P_COO2_crd = (int32_t*)malloc(sizeof(int32_t) * P_COO2_crd_size);
  int32_t uP_COO = 0;
  int32_t P_COO_capacity = 1048576;
  P_COO_vals = (double*)malloc(sizeof(double) * P_COO_capacity);


  for (int32_t a = 0; a < P1_dimension; a++) {
    for (int32_t u = 0; u < P2_dimension; u++) {
      if (P_COO_capacity <= uP_COO) {
        P_COO_vals = (double*)realloc(P_COO_vals, sizeof(double) * (P_COO_capacity * 2));
        P_COO_capacity *= 2;
      }
      int32_t uP = a * P2_dimension + u;
      P_COO_vals[uP_COO] = P_vals[uP];
      if (P_COO2_crd_size <= uP_COO) {
        int32_t P_COO2_crd_new_size = TACO_MAX(P_COO2_crd_size * 2,(uP_COO + 1));
        P_COO2_crd = (int32_t*)realloc(P_COO2_crd, sizeof(int32_t) * P_COO2_crd_new_size);
        P_COO2_crd_size = P_COO2_crd_new_size;
      }
      P_COO2_crd[uP_COO] = u;
      if (P_COO1_crd_size <= uP_COO) {
        P_COO1_crd = (int32_t*)realloc(P_COO1_crd, sizeof(int32_t) * (P_COO1_crd_size * 2));
        P_COO1_crd_size *= 2;
      }
      P_COO1_crd[uP_COO] = a;
      uP_COO++;
    }
  }

  P_COO1_pos[1] = uP_COO;

  *P_COO1_pos_ptr = P_COO1_pos;
  *P_COO1_crd_ptr = P_COO1_crd;
  *P_COO2_crd_ptr = P_COO2_crd;
  *P_COO_vals_ptr = P_COO_vals;
  return 0;
}
